#!/usr/bin/sage -python
from EllipticCurve import EllipticCurveStandard
from SampleFunctions import showRelatedPoints

class DoubleAndAdd3p(EllipticCurveStandard):
    a = -4.5
    b = 5
    xMax = 4
    xMin = -3

    def createEllipticCurve(self):
        result = self.ellipticCurve()

        px = -0.5
        p = (px, self.curveFunction(px))
        result += self.point(p, 'p')

        p2 = self.addPoints(p, p)
        result += self.point(p2, '2p')
        p2negative = (p2[0], -p2[1])
        result += self.point(p2negative, '-2p')
        result = showRelatedPoints(self, p, p2, result)

        p3 = self.doubleAndAdd(p, 3)
        result += self.point(p3, '3p')
        p3negative = (p3[0], -p3[1])
        result += self.point(p3negative, '-3p')
        result = showRelatedPoints(self, p, p3, result)

        return result

if __name__ == "__main__":
    DoubleAndAdd3p().run()
