#!/usr/bin/sage -python
from EllipticCurve import EllipticCurveStandard

class DoubleAndAdd9p(EllipticCurveStandard):
    a = -5
    b = 5
    xMax = 4
    xMin = -3

    def createEllipticCurve(self):
        result = self.ellipticCurve()

        px = -0.5
        p = (px, self.curveFunction(px))
        result += self.point(p, 'P')

        p2 = self.addPoints(p, p)
        result += self.point(p2, '2P')
        p2negative = (p2[0], -p2[1])
        result += self.point(p2negative, '-2P')
        result += self.finiteLine(p, p2negative, '-')
        result += self.finiteLine(p2negative, p2, '--')

        p22 = self.addPoints(p2, p2)
        result += self.point(p22, '2(2P)')
        p22negative = (p22[0], -p22[1])
        result += self.point(p22negative, '-2(2P)')
        result += self.finiteLine(p22, p22negative, '--')
        result += self.finiteLine(p2, p22negative, '-')

        p222 = self.addPoints(p22, p22)
        result += self.point(p222, '2(2(2P))')
        p222negative = (p222[0], -p222[1])
        result += self.point(p222negative, '-2(2(2P))')
        result += self.finiteLine(p22, p222negative, '-')
        result += self.finiteLine(p222negative, p222, '--')

        p9 = self.doubleAndAdd(p, 9)
        result += self.point(p9, '9P')
        p9negative = (p9[0], -p9[1])
        result += self.point(p9negative, '-9P')
        result += self.finiteLine(p9negative, p222, '-')
        result += self.finiteLine(p9negative, p9, '--')


        return result

if __name__ == "__main__":
    s = DoubleAndAdd9p()
    s.run()

