#!/usr/bin/sage -python
from EllipticCurve import EllipticCurve

class SampleDoubling37(EllipticCurve):
    xMax = 4
    a = -3
    b = 7
    
    def createEllipticCurve(self):
        result = self.ellipticCurve()
        
        px = -1.1
        p = (px, self.curveFunction(px))
        result += self.point(p, 'P')
        
        p2 = self.addPoints(p,p)
        result += self.point(p2, '2P')
        result += self.finiteLine(p,p2)
        
        p3 = self.addPoints(p2,p)
        result += self.point(p3, '3P')
        result += self.finiteLine(p2,p3)
        
        p3p = self.addPoints(p3, p)
        result += self.point(p3p, '3P+P')
        result += self.finiteLine(p3p,p)

#        p22 = self.addPoints(p2,p2)
#        result += self.point(p22, '2(2P)')
#        result += self.finiteLine(p2,p22)
        
#        p222 = self.addPoints(p22,p22)
#        result += self.point(p222, '2(2(2P))')
#        result += self.finiteLine(p22,p222)
#        
#        p222p = self.addPoints(p222, p)
#        result += self.point(p222p, '2(2(2P)) + P')
#        result += self.finiteLine(p222,p)
        

        return result

if __name__ == "__main__":
    s = SampleDoubling37()
    s.run()
